/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the Activity type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Activity{}

// Activity activity
type Activity struct {
	Id *string `json:"id,omitempty"`
	Type string `json:"type"`
	OrganizationId *string `json:"organization_id,omitempty"`
	ContactId *string `json:"contact_id,omitempty"`
	LocationId *string `json:"location_id,omitempty"`
	TransactionId *string `json:"transaction_id,omitempty"`
	ConversationId *string `json:"conversation_id,omitempty"`
	Attributes *map[string][]string `json:"attributes,omitempty"`
	CreatedAt *time.Time `json:"created_at,omitempty"`
	UpdatedAt *time.Time `json:"updated_at,omitempty"`
	OrganizationCount int32 `json:"organization_count"`
	LocationCount int32 `json:"location_count"`
	OccuredAt *time.Time `json:"occured_at,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	EntryPointId *string `json:"entry_point_id,omitempty"`
	State *string `json:"state,omitempty"`
	File *ActivityFile `json:"file,omitempty"`
}

// NewActivity instantiates a new Activity object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivity(type_ string, organizationCount int32, locationCount int32) *Activity {
	this := Activity{}
	this.Type = type_
	this.OrganizationCount = organizationCount
	this.LocationCount = locationCount
	return &this
}

// NewActivityWithDefaults instantiates a new Activity object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivityWithDefaults() *Activity {
	this := Activity{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *Activity) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *Activity) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *Activity) SetId(v string) {
	o.Id = &v
}

// GetType returns the Type field value
func (o *Activity) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Activity) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Activity) SetType(v string) {
	o.Type = v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *Activity) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *Activity) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *Activity) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetContactId returns the ContactId field value if set, zero value otherwise.
func (o *Activity) GetContactId() string {
	if o == nil || IsNil(o.ContactId) {
		var ret string
		return ret
	}
	return *o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetContactIdOk() (*string, bool) {
	if o == nil || IsNil(o.ContactId) {
		return nil, false
	}
	return o.ContactId, true
}

// HasContactId returns a boolean if a field has been set.
func (o *Activity) HasContactId() bool {
	if o != nil && !IsNil(o.ContactId) {
		return true
	}

	return false
}

// SetContactId gets a reference to the given string and assigns it to the ContactId field.
func (o *Activity) SetContactId(v string) {
	o.ContactId = &v
}

// GetLocationId returns the LocationId field value if set, zero value otherwise.
func (o *Activity) GetLocationId() string {
	if o == nil || IsNil(o.LocationId) {
		var ret string
		return ret
	}
	return *o.LocationId
}

// GetLocationIdOk returns a tuple with the LocationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetLocationIdOk() (*string, bool) {
	if o == nil || IsNil(o.LocationId) {
		return nil, false
	}
	return o.LocationId, true
}

// HasLocationId returns a boolean if a field has been set.
func (o *Activity) HasLocationId() bool {
	if o != nil && !IsNil(o.LocationId) {
		return true
	}

	return false
}

// SetLocationId gets a reference to the given string and assigns it to the LocationId field.
func (o *Activity) SetLocationId(v string) {
	o.LocationId = &v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *Activity) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *Activity) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *Activity) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetConversationId returns the ConversationId field value if set, zero value otherwise.
func (o *Activity) GetConversationId() string {
	if o == nil || IsNil(o.ConversationId) {
		var ret string
		return ret
	}
	return *o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetConversationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConversationId) {
		return nil, false
	}
	return o.ConversationId, true
}

// HasConversationId returns a boolean if a field has been set.
func (o *Activity) HasConversationId() bool {
	if o != nil && !IsNil(o.ConversationId) {
		return true
	}

	return false
}

// SetConversationId gets a reference to the given string and assigns it to the ConversationId field.
func (o *Activity) SetConversationId(v string) {
	o.ConversationId = &v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *Activity) GetAttributes() map[string][]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string][]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetAttributesOk() (*map[string][]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *Activity) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string][]string and assigns it to the Attributes field.
func (o *Activity) SetAttributes(v map[string][]string) {
	o.Attributes = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *Activity) GetCreatedAt() time.Time {
	if o == nil || IsNil(o.CreatedAt) {
		var ret time.Time
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *Activity) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given time.Time and assigns it to the CreatedAt field.
func (o *Activity) SetCreatedAt(v time.Time) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *Activity) GetUpdatedAt() time.Time {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret time.Time
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *Activity) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given time.Time and assigns it to the UpdatedAt field.
func (o *Activity) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = &v
}

// GetOrganizationCount returns the OrganizationCount field value
func (o *Activity) GetOrganizationCount() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.OrganizationCount
}

// GetOrganizationCountOk returns a tuple with the OrganizationCount field value
// and a boolean to check if the value has been set.
func (o *Activity) GetOrganizationCountOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationCount, true
}

// SetOrganizationCount sets field value
func (o *Activity) SetOrganizationCount(v int32) {
	o.OrganizationCount = v
}

// GetLocationCount returns the LocationCount field value
func (o *Activity) GetLocationCount() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.LocationCount
}

// GetLocationCountOk returns a tuple with the LocationCount field value
// and a boolean to check if the value has been set.
func (o *Activity) GetLocationCountOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LocationCount, true
}

// SetLocationCount sets field value
func (o *Activity) SetLocationCount(v int32) {
	o.LocationCount = v
}

// GetOccuredAt returns the OccuredAt field value if set, zero value otherwise.
func (o *Activity) GetOccuredAt() time.Time {
	if o == nil || IsNil(o.OccuredAt) {
		var ret time.Time
		return ret
	}
	return *o.OccuredAt
}

// GetOccuredAtOk returns a tuple with the OccuredAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetOccuredAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.OccuredAt) {
		return nil, false
	}
	return o.OccuredAt, true
}

// HasOccuredAt returns a boolean if a field has been set.
func (o *Activity) HasOccuredAt() bool {
	if o != nil && !IsNil(o.OccuredAt) {
		return true
	}

	return false
}

// SetOccuredAt gets a reference to the given time.Time and assigns it to the OccuredAt field.
func (o *Activity) SetOccuredAt(v time.Time) {
	o.OccuredAt = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *Activity) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *Activity) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *Activity) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetEntryPointId returns the EntryPointId field value if set, zero value otherwise.
func (o *Activity) GetEntryPointId() string {
	if o == nil || IsNil(o.EntryPointId) {
		var ret string
		return ret
	}
	return *o.EntryPointId
}

// GetEntryPointIdOk returns a tuple with the EntryPointId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetEntryPointIdOk() (*string, bool) {
	if o == nil || IsNil(o.EntryPointId) {
		return nil, false
	}
	return o.EntryPointId, true
}

// HasEntryPointId returns a boolean if a field has been set.
func (o *Activity) HasEntryPointId() bool {
	if o != nil && !IsNil(o.EntryPointId) {
		return true
	}

	return false
}

// SetEntryPointId gets a reference to the given string and assigns it to the EntryPointId field.
func (o *Activity) SetEntryPointId(v string) {
	o.EntryPointId = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *Activity) GetState() string {
	if o == nil || IsNil(o.State) {
		var ret string
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetStateOk() (*string, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *Activity) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given string and assigns it to the State field.
func (o *Activity) SetState(v string) {
	o.State = &v
}

// GetFile returns the File field value if set, zero value otherwise.
func (o *Activity) GetFile() ActivityFile {
	if o == nil || IsNil(o.File) {
		var ret ActivityFile
		return ret
	}
	return *o.File
}

// GetFileOk returns a tuple with the File field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Activity) GetFileOk() (*ActivityFile, bool) {
	if o == nil || IsNil(o.File) {
		return nil, false
	}
	return o.File, true
}

// HasFile returns a boolean if a field has been set.
func (o *Activity) HasFile() bool {
	if o != nil && !IsNil(o.File) {
		return true
	}

	return false
}

// SetFile gets a reference to the given ActivityFile and assigns it to the File field.
func (o *Activity) SetFile(v ActivityFile) {
	o.File = &v
}

func (o Activity) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Activity) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	toSerialize["type"] = o.Type
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ContactId) {
		toSerialize["contact_id"] = o.ContactId
	}
	if !IsNil(o.LocationId) {
		toSerialize["location_id"] = o.LocationId
	}
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.ConversationId) {
		toSerialize["conversation_id"] = o.ConversationId
	}
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	toSerialize["organization_count"] = o.OrganizationCount
	toSerialize["location_count"] = o.LocationCount
	if !IsNil(o.OccuredAt) {
		toSerialize["occured_at"] = o.OccuredAt
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.EntryPointId) {
		toSerialize["entry_point_id"] = o.EntryPointId
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if !IsNil(o.File) {
		toSerialize["file"] = o.File
	}
	return toSerialize, nil
}

type NullableActivity struct {
	value *Activity
	isSet bool
}

func (v NullableActivity) Get() *Activity {
	return v.value
}

func (v *NullableActivity) Set(val *Activity) {
	v.value = val
	v.isSet = true
}

func (v NullableActivity) IsSet() bool {
	return v.isSet
}

func (v *NullableActivity) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivity(val *Activity) *NullableActivity {
	return &NullableActivity{value: val, isSet: true}
}

func (v NullableActivity) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivity) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


